/* ************************************************************************
*   File: screen.h                                      Part of CircleMUD *
*  Usage: header file with ANSI color codes for online color              *
*                                                                         *
*  All rights reserved.  See license.doc for complete information.        *
*                                                                         *
*  Copyright (C) 1993, 94 by the Trustees of the Johns Hopkins University *
*  CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.               *
************************************************************************ */

#include "screen.h"


/* Attribute codes:                                                       */
/* 00=none 01=bold 04=underscore 05=blink 07=reverse 08=concealed         */
/* Text color codes:                                                      */
/* 30=black 31=red 32=green 33=yellow 34=blue 35=magenta 36=cyan 37=white */
/* Background color codes:                                                */
/* 40=black 41=red 42=green 43=yellow 44=blue 45=magenta 46=cyan 47=white */

const char *KNRM  = "\e[0m";    /* Clears Color */
const char *KBLK  = "\e[0;30m";
const char *KRED  = "\e[0;31m";  /* Standard Colors */
const char *KGRN  = "\e[0;32m";
const char *KYEL  = "\e[0;33m";
const char *KBLU  = "\e[0;34m";
const char *KMAG  = "\e[0;35m";
const char *KCYN  = "\e[0;36m";
const char *KWHT  = "\e[0;37m";

const char *CGLOB = KNRM;

const char *B_BLK      =     "\e[1;30m";
const char *B_RED      =     "\e[1;31m";  /* Bold Colors */
const char *B_GREEN    =     "\e[1;32m";
const char *B_YELLOW   =     "\e[1;33m";
const char *B_BLUE     =     "\e[1;34m";
const char *B_MAGENTA  =     "\e[1;35m";
const char *B_CYAN     =     "\e[1;36m";
const char *B_WHITE    =     "\e[1;37m";
const char *BL_RED     =     "\e[5;31m";  /* Blinking Colors */
const char *BL_GREEN   =     "\e[5;32m";
const char *BL_YELLOW  =     "\e[5;33m";
const char *BL_BLUE    =     "\e[5;34m";
const char *BL_MAGENTA =     "\e[5;35m";
const char *BL_CYAN    =     "\e[5;36m";
const char *BL_WHITE   =     "\e[5;37m";
const char *BB_RED     =     "\e[1;5;31m"; /* Bold Blinking Colors */
const char *BB_GREEN   =     "\e[1;5;32m";
const char *BB_YELLOW  =     "\e[1;5;33m";
const char *BB_BLUE    =     "\e[1;5;34m";
const char *BB_MAGENTA =     "\e[1;5;35m";
const char *BB_CYAN    =     "\e[1;5;36m";
const char *BB_WHITE   =     "\e[1;5;37m";
const char *H_RED      =     "\e[7;31m";  /* Highlighted (Inverse) Colors */
const char *H_GREEN    =     "\e[7;32m";
const char *H_YELLOW   =     "\e[7;33m";
const char *H_BLUE     =     "\e[7;34m";
const char *H_MAGENTA  =     "\e[7;35m";
const char *H_CYAN     =     "\e[7;36m";
const char *H_WHITE    =     "\e[7;37m";
const char *KNUL  = "";
